#! /bin/sh
#
# Bill Beavis
#
#  todo:  better checking for commandline arguments

CLIMIT=0.01
WLIMIT=0.5
STATE_OK=0
STATE_CRITICAL=2
STATE_WARNING=1
EXIT_STATE=$STATE_OK

printProcess()
{
colsize[1]=10
colsize[2]=10
colsize[3]=20
colsize[4]=20
colsize[5]=10

let i=1
let flag=0
echo "%Mem       %CPU       Command             User                PID       Time" 
for z in `ps -eo pmem,pcpu,comm,user,pid,time |sort -rnk1`

do
	echo -n $z
	
	
	if [ "$flag" -eq "0" ] && [ "$i" -eq "2" ]
	then
		if [ `echo $z $CLIMIT |awk '{print ($1 > $2)  ? "true" : "false" }'` = "true" ]
		
		then
			let EXIT_STATE=$STATE_CRITICAL
		elif [ `echo $z $WLIMIT |awk '{print ($1 > $2)  ? "true" : "false" }'` = "true" ]
		then 
			let EXIT_STATE=$STATE_WARNING
		else
			
			let EXIT_STATE=$STATE_OK
		fi
		let flag=1
	fi
	
	if [ "$i" -eq "6" ]
	then
	   	echo "\n"
		let i=0
	else
		length=`echo $z | wc -c | cut -c1-8`
			       let length=$length -1
			     
			      if [ "$length" -lt "colsize[i]" ]
			      then
			            let nosp=colsize[i]-length
			            let j=1
			            while [ "$j" -lt "$nosp" ]
				     do
				    	echo -n " "
				    	let j=j+1
			      	     done
			      			       	    	      	       	
	       		       fi
		
	fi
	let i=i+1

done
}

print_help() {
	echo ""
	echo "Usage: check_top_process -w <warning> -c <critical>"
	echo ""
	echo "This plugin checks the top running process."
	echo ""
	exit 0
}

case "$1" in
	-w)
		WLIMIT=$2
		CLIMIT=$4
		;;
	-c)
		CLIMIT=$2
		WLIMIT=$4
		;;
	--help)
		print_help
		exit $STATE_OK
		;;
	-h)
		print_help
		exit $STATE_OK
		;;
	*) printProcess
	exit $EXIT_STATE
		;;
esac

if [ `echo $WLIMIT $CLIMIT |awk '{print ($1 > $2)  ? "true" : "false" }'` = "true" ]
then
	echo "Error: WARNING value must be below CRITICAL value"
	print_help
	exit $STATE_OK
fi





